<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (134)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="fetch-download-progress">Fetch: Download progress</h1>
    <p>
      The <code>fetch</code> method allows to track <em>download</em> progress.
    </p>
    <p>
      Please note: there’s currently no way for <code>fetch</code> to track
      <em>upload</em> progress. For that purpose, please use
      <a href="info:xmlhttprequest">XMLHttpRequest</a>, we’ll cover it later.
    </p>
    <p>
      To track download progress, we can use
      <code>response.body</code> property. It’s <code>ReadableStream</code> – a
      special object that provides body chunk-by-chunk, as it comes. Readable
      streams are described in the
      <a href="https://streams.spec.whatwg.org/#rs-class">Streams API</a>
      specification.
    </p>
    <p>
      Unlike <code>response.text()</code>, <code>response.json()</code> and
      other methods, <code>response.body</code> gives full control over the
      reading process, and we can count how much is consumed at any moment.
    </p>
    <p>
      Here’s the sketch of code that reads the response from
      <code>response.body</code>:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="co">// instead of response.json() and other methods</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="kw">const</span> reader <span class="op">=</span> <span class="va">response</span>.<span class="va">body</span>.<span class="at">getReader</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">// infinite loop while the body is downloading</span></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="cf">while</span> (<span class="kw">true</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-6" title="6">  <span class="co">// done is true for the last chunk</span></a>
<a class="sourceLine" id="cb1-7" title="7">  <span class="co">// value is Uint8Array of the chunk bytes</span></a>
<a class="sourceLine" id="cb1-8" title="8">  <span class="kw">const</span> <span class="op">{</span> done<span class="op">,</span> value <span class="op">}</span> <span class="op">=</span> <span class="cf">await</span> <span class="va">reader</span>.<span class="at">read</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-9" title="9"></a>
<a class="sourceLine" id="cb1-10" title="10">  <span class="cf">if</span> (done) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-11" title="11">    <span class="cf">break</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-13" title="13"></a>
<a class="sourceLine" id="cb1-14" title="14">  <span class="va">console</span>.<span class="at">log</span>(<span class="vs">`Received </span><span class="sc">${</span><span class="va">value</span>.<span class="at">length</span><span class="sc">}</span><span class="vs"> bytes`</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-15" title="15"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      The result of <code>await reader.read()</code> call is an object with two
      properties:
    </p>
    <ul>
      <li>
        <strong><code>done</code></strong> – <code>true</code> when the reading
        is complete, otherwise <code>false</code>.
      </li>
      <li>
        <strong><code>value</code></strong> – a typed array of bytes:
        <code>Uint8Array</code>.
      </li>
    </ul>
    <pre
      class="smart"
    ><code>Streams API also describes asynchronous iteration over `ReadableStream` with `for await..of` loop, but it&#39;s not yet widely supported (see [browser issues](https://github.com/whatwg/streams/issues/778#issuecomment-461341033)), so we use `while` loop.</code></pre>
    <p>
      We receive response chunks in the loop, until the loading finishes, that
      is: until <code>done</code> becomes <code>true</code>.
    </p>
    <p>
      To log the progress, we just need for every received fragment
      <code>value</code> to add its length to the counter.
    </p>
    <p>
      Here’s the full working example that gets the response and logs the
      progress in console, more explanations to follow:
    </p>
    <p>
      ```js run async // Step 1: start the fetch and obtain a reader let
      response = await fetch(
      “https://api.github.com/repos/javascript-tutorial/en.javascript.info/commits?per_page=100”
      );
    </p>
    <p>const reader = response.body.getReader();</p>
    <p>
      // Step 2: get total length const contentLength =
      +response.headers.get(“Content-Length”);
    </p>
    <p>
      // Step 3: read the data let receivedLength = 0; // received that many
      bytes at the moment let chunks = []; // array of received binary chunks
      (comprises the body) while (true) { const { done, value } = await
      reader.read();
    </p>
    <p>if (done) { break; }</p>
    <p>chunks.push(value); receivedLength += value.length;</p>
    <p>
      console.log(<code>Received ${receivedLength} of ${contentLength}</code>);
      }
    </p>
    <p>
      // Step 4: concatenate chunks into single Uint8Array let chunksAll = new
      Uint8Array(receivedLength); // (4.1) let position = 0; for (let chunk of
      chunks) { chunksAll.set(chunk, position); // (4.2) position +=
      chunk.length; }
    </p>
    <p>
      // Step 5: decode into a string let result = new
      TextDecoder(“utf-8”).decode(chunksAll);
    </p>
    <p>// We’re done! let commits = JSON.parse(result); ```</p>
    <p>Let’s explain that step-by-step:</p>
    <ol type="1">
      <li>
        <p>
          We perform <code>fetch</code> as usual, but instead of calling
          <code>response.json()</code>, we obtain a stream reader
          <code>response.body.getReader()</code>.
        </p>
        <p>
          Please note, we can’t use both these methods to read the same
          response: either use a reader or a response method to get the result.
        </p>
      </li>
      <li>
        <p>
          Prior to reading, we can figure out the full response length from the
          <code>Content-Length</code> header.
        </p>
        <p>
          It may be absent for cross-origin requests (see chapter
          <a href="info:fetch-crossorigin" class="uri">info:fetch-crossorigin</a
          >) and, well, technically a server doesn’t have to set it. But usually
          it’s at place.
        </p>
      </li>
      <li>
        <p>Call <code>await reader.read()</code> until it’s done.</p>
        <p>
          We gather response chunks in the array <code>chunks</code>. That’s
          important, because after the response is consumed, we won’t be able to
          “re-read” it using <code>response.json()</code> or another way (you
          can try, there’ll be an error).
        </p>
      </li>
      <li>
        At the end, we have <code>chunks</code> – an array of
        <code>Uint8Array</code> byte chunks. We need to join them into a single
        result. Unfortunately, there’s no single method that concatenates those,
        so there’s some code to do that:
        <ol type="1">
          <li>
            We create <code>chunksAll = new Uint8Array(receivedLength)</code> –
            a same-typed array with the combined length.
          </li>
          <li>
            Then use <code>.set(chunk, position)</code> method to copy each
            <code>chunk</code> one after another in it.
          </li>
        </ol>
      </li>
      <li>
        <p>
          We have the result in <code>chunksAll</code>. It’s a byte array
          though, not a string.
        </p>
        <p>
          To create a string, we need to interpret these bytes. The built-in
          <a href="info:text-decoder">TextDecoder</a> does exactly that. Then we
          can <code>JSON.parse</code> it, if necessary.
        </p>
        <p>
          What if we need binary content instead of a string? That’s even
          simpler. Replace steps 4 and 5 with a single line that creates a
          <code>Blob</code> from all chunks:
        </p>
        <div class="sourceCode" id="cb3">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> blob <span class="op">=</span> <span class="kw">new</span> <span class="at">Blob</span>(chunks)<span class="op">;</span></a></code></pre>
        </div>
      </li>
    </ol>
    <p>
      At the end we have the result (as a string or a blob, whatever is
      convenient), and progress-tracking in the process.
    </p>
    <p>
      Once again, please note, that’s not for <em>upload</em> progress (no way
      now with <code>fetch</code>), only for <em>download</em> progress.
    </p>
    <p>
      Also, if the size is unknown, we should check
      <code>receivedLength</code> in the loop and break it once it reaches a
      certain limit. So that the <code>chunks</code> won’t overflow the memory.
    </p>
  </body>
</html>
